<template>
  <div class="container has-text-left pb-5">
    <div class="level">
      <div class="level-left">
        <p class="mb-3"><em>Active agents that are configured for this OpenAPI Data App instance, with the possibility to add, modify, or delete agents.</em></p>
      </div>
      <div class="level-left">
        <div class="control">
          <b-switch v-model="searchable">Searchable</b-switch>
        </div>
      </div>
    </div>
    <b-table
      :data="agents"
      paginated
      per-page="20"
      detailed
      detail-key="id"
      >
        <b-table-column field="id" label="ID" :searchable="searchable" sortable v-slot="props">
          {{ props.row.id }}
        </b-table-column>
        <b-table-column field="title" label="Title" :searchable="searchable" sortable v-slot="props">
          {{ props.row.title }}
        </b-table-column>
        <b-table-column field="actions" label="Actions" v-slot="props">
          <b-button type="is-warning"
              icon-right="pencil" outlined class="mr-2" @click="() => { modal = {active: true, agent: props.row, type: 'update'}}"/>
          <b-button type="is-danger"
              icon-right="delete" outlined @click="deleteAgent(props.row.id, $event)"/>
        </b-table-column>
        <template #detail="props">
          <Agent :agentConfig="props.row" :openApiConfig="config" />
        </template>
    </b-table>

    <b-button type="is-success" @click="() => { modal = {active: true, agent: {id:''}, type: 'create'}} ">Add agent</b-button>

    <AgentForm v-if="modal.active" :agentConfig="modal.agent" :openApiConfig="config" :type="modal.type" @close="() => {modal.active = false}" @updated="getAgents"  />
  </div>
</template>

<script lang="ts">
import { Component, Prop, Vue, Watch } from 'vue-property-decorator';
import axios from 'axios';
import moment from 'moment-timezone';
import { AgentConfig, HTMLEvent, OpenApiConfig } from '../model'
import Agent from '../components/Agent.vue'
import AgentForm from '../components/AgentForm.vue'

@Component({
  filters: {
    formatDate: (date: Date): string => {
      return moment(date).tz(moment.tz.guess()).format('YYYY-MM-DD')
    }
  },
  components: {
    Agent,
    AgentForm
  }
})
export default class Agents extends Vue {
  modal: {
    active: boolean,
    agent: AgentConfig,
    type: string
  } = {
    active: false,
    agent: {
      id: ''
    },
    type: 'update'
  }
  searchable = false
  agents: Array<AgentConfig> = []
  //   {
  //     "id": "urn:aas:99000002",
  //     "title": "TNO PEF Test B Agent",
  //     "config": undefined,
  //     "backendUrl": undefined,
  //     "backendUrlMapping": {
  //       "v1": "http://aic-pef-b-tsg-connector-basyx-server-http:4001/aasServer",
  //       "v2": "http://aic-pef-b-tsg-connector-basyx-server-http:4001/aasServer"
  //     },
  //     "versions": undefined,
  //     "openApiBaseUrl": undefined,
  //     "backendAuthentication": {
  //       "type": "BASIC",
  //       "username": "admin",
  //       "password": "admin"
  //     }
  //   },
  //   {
  //     "id": "urn:aas:99000003",
  //     "title": "TNO PEF Test B Agent 2",
  //     "config": undefined,
  //     "backendUrl": "http://aic-pef-b-tsg-connector-basyx-server-http:4001/aasServer",
  //     "backendUrlMapping": undefined,
  //     "openApiBaseUrl": undefined,
  //     "backendAuthentication": {
  //       "type": "BEARER",
  //       "token": "APIKEY-1234"
  //     }
  //   },
  //   {
  //     "id": "urn:aas:99000004",
  //     "title": "TNO PEF Test B Agent 3",
  //     "config": undefined,
  //     "versions": ["v1"],
  //     "openApiBaseUrl": undefined,
  //     "backendAuthentication": {
  //       "type": "CUSTOM",
  //       "header": {
  //         "X-API-KEY": "APIKEY-1234",
  //         "X-Realm": "APIMGMT"
  //       }
  //     }
  //   }
  // ]

  config: OpenApiConfig = {
    validate: false,
    usePolicyEnforcement: true,
    openApiBaseUrl: "https://app.swaggerhub.com/apiproxy/registry/BaSyx/basyx_asset_administration_shell_repository_http_rest_api/",
    // "backendBaseUrl": "http://generic-aas-server:4001/aasServer",
    "versions":[
      "v1"//, "v2"
    ]
  }

  private api = axios.create({
    baseURL: 'mgmt',
  });

  async created() {
    await Promise.all([
      this.getAgents()
    ]);
  }

  async getAgents() {
    const agents = await this.api.get('agents');
    this.agents = agents.data;
  }

  async deleteAgent(agentId: string, event: HTMLEvent) {
    event.target?.classList.add("is-loading")
    try {
      await this.api.delete(`agents/${encodeURIComponent(agentId)}`);
      await this.getAgents();
      this.$buefy.toast.open({
        message: `Successfully deleted agent ${agentId}`,
        type: 'is-success'
      });

    } catch (e) {
      this.$buefy.toast.open({
        message: `Can't delete agent ${agentId}`,
        type: 'is-danger'
      });
    }
    event.target?.classList.remove("is-loading")
  }
}
</script>
